Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Grid.Grouping
Imports Syncfusion.Windows.Forms
Imports Syncfusion.Grouping

Public Class Form1

    Private customLabel As Label
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        SetUpData()

        Me.GridGroupingControl1.ShowNavigationBar = True

        'setup the custom label
        Dim bar As RecordNavigationScrollBar = Me.GridGroupingControl1.RecordNavigationControl.NavigationBar
        customLabel = New Label()
        customLabel.Anchor = AnchorStyles.Left Or AnchorStyles.Top
        'center the label text if you like
        'customLabel.TextAlign = ContentAlignment.TopCenter
        customLabel.BringToFront()
        customLabel.Text = GetLabel()
        customLabel.Location = New Point(bar.ButtonBarChild.Buttons(2).Bounds.X, 0)
        customLabel.Width = bar.ButtonBarChild.Buttons(5).Bounds.X - customLabel.Location.X
        Me.GridGroupingControl1.RecordNavigationControl.NavigationBar.Controls.Add(customLabel)
        AddHandler bar.CurrentRecordChanged, AddressOf Grid_CurrentRecordChanged

    End Sub

    'provides the custom label
    Private Function GetLabel() As String

        Dim r As Record = Me.GridGroupingControl1.Table.CurrentRecord
        If Me.GridGroupingControl1.Table.CurrentElement Is GetType(GridNestedTable) Then
            r = Me.GridGroupingControl1.Table.CurrentElement.ParentRecord

        End If
        Dim current As Integer = Me.GridGroupingControl1.Table.FilteredRecords.IndexOf(r) + 1
        Dim max As Integer = Me.GridGroupingControl1.Table.FilteredRecords.Count

        Return String.Format("Eintrag {0} von {1}", current, max)

    End Function

    'handles the changing of the label as the current item moves
    Private Shadows Sub Grid_CurrentRecordChanged(ByVal sender As Object, ByVal e As CurrentRecordEventArgs)
        customLabel.Text = GetLabel()
    End Sub


#Region "Set Up The Data"
    Private Sub SetUpData()

        Dim parentTable As DataTable = GetParentTable()
        Dim childTable As DataTable = GetChildTable()
        Dim grandChildTable As DataTable = GetGrandChildTable()

        Dim ds As DataSet = New DataSet()
        ds.Tables.AddRange(New DataTable() {parentTable, childTable, grandChildTable})

        Dim parentToChild As DataRelation = New DataRelation("ParentToChild", parentTable.Columns("parentID"), childTable.Columns("ParentID"))
        Dim childToGrandChild As DataRelation = New DataRelation("ChildToGrandChild", childTable.Columns("childID"), grandChildTable.Columns("ChildID"))

        ds.Relations.AddRange(New DataRelation() {parentToChild, childToGrandChild})

        Me.GridGroupingControl1.DataSource = parentTable



    End Sub



    Private numberParentRows As Integer = 45
    Private numberChildRows As Integer = 20
    Private numberGrandChildRows As Integer = 50
    Private Function GetParentTable() As DataTable
        Dim dt As DataTable = New DataTable("ParentTable")


        dt.Columns.Add(New DataColumn("ParentName"))
        dt.Columns.Add(New DataColumn("parentID")) 'lower case p
        dt.Columns.Add(New DataColumn("ParentDec"))

        Dim i As Integer = 0
        'ORIGINAL LINE: for(int i = 0; i < numberParentRows; i += 1)
        'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
        Do While i < numberParentRows
            Dim dr As DataRow = dt.NewRow()
            dr(1) = i '.ToString();
            dr(0) = String.Format("parent some long Name{0}", i)
            dr(2) = String.Format("desc{0}", i)
            dt.Rows.Add(dr)
            i += 1
        Loop

        Return dt
    End Function

    Private Function GetChildTable() As DataTable
        Dim dt As DataTable = New DataTable("ChildTable")

        dt.Columns.Add(New DataColumn("childID")) 'lower case c
        dt.Columns.Add(New DataColumn("Name"))
        dt.Columns.Add(New DataColumn("ParentID")) 'upper case P
        dt.Columns.Add(New DataColumn("other", GetType(Integer))) 'upper case P
        dt.Columns.Add(New DataColumn("otherx")) 'upper case P
        Dim r As New Random
        Dim i As Integer = 0
        'ORIGINAL LINE: for(int i = 0; i < numberChildRows; i += 1)
        'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
        Do While i < numberChildRows
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = String.Format("ChildName{0}", i)
            dr(2) = (i Mod numberParentRows).ToString()
            dr(3) = r.Next(100000)
            dr(4) = String.Format("otherx{0}", i)
            dt.Rows.Add(dr)
            i += 1
        Loop

        Return dt
    End Function

    Private Function GetGrandChildTable() As DataTable
        Dim dt As DataTable = New DataTable("GrandChildTable")

        dt.Columns.Add(New DataColumn("GrandChildID"))
        dt.Columns.Add(New DataColumn("Name"))
        dt.Columns.Add(New DataColumn("ChildID")) 'upper case C

        Dim i As Integer = 0
        'ORIGINAL LINE: for(int i = 0; i < numberGrandChildRows; i += 1)
        'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
        Do While i < numberGrandChildRows
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = String.Format("GrandChildName{0}", i)
            dr(2) = (i Mod numberChildRows).ToString()
            dt.Rows.Add(dr)
            i += 1
        Loop

        Return dt
    End Function
#End Region


    Private Sub ToolStripTextBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripTextBox1.Click
        Console.WriteLine(ToolStripTextBox1.Text)
    End Sub

    Private Sub DoSomethingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DoSomethingToolStripMenuItem.Click

    End Sub

    Private Sub ToolStripTextBox1_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripTextBox1.Leave
        Console.WriteLine(ToolStripTextBox1.Text)
    End Sub
End Class
